Subject: bug#29165: 26.0.90; can't use some code byte-compiled under emacs 24

From: Noam Postavsky <[email-masked]>
Date: Mon, 13 Nov 2017 13:06:42 -0500

On Mon, Nov 6, 2017 at 2:16 PM, Noam Postavsky
<[email-masked]> wrote:
> On Mon, Nov 6, 2017 at 2:10 PM, Ken Raeburn <[email-masked]> wrote:
>
>> It appears that the emacs-26 version of defun* is happy with it (the
>> original Lisp code I posted, using &optional &key) as well, as long as I
>> provide the source, or a byte-compiled file from Emacs 25 or 26
>
> It looks like the cl-defun in newer Emacs throws away the &optional
> for you in this case.

I think we should make cl-defun reject this kind of code, to be
consistent with plain defun. See attached.